# 
# UniSysDB library in Ruby
# Copyright (C) 2012
#
# author: Natapol Pornputtapong <natapol@chalmers.se>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#
# This class is used by Ondine

module Sylfy
    
    class Feature
        
        attr_reader :member, :listnumber, :length
        
        def initialize(listnumber, member, length)
            @listnumber = listnumber
            @member = member
            @length = length
        end
        
        protected :initialize
        
        def self.open(filename, options)
            #@listnumber = {:path => { "path:map00010"=>["Glycolysis / Gluconeogenesis"], ...}, "gene" => {"path:map00010"=>["ko:K00001", "ko:K00002", ...], ...}, "comp" => {... }
            #"ko:K02790"=>{"gene"=>["path:map00010", "path:map00500", "path:map02060"]}
            listnumber = {}
            member = {}
            length = {}
            # type group member
            CSV.open(filename, "rb", options).readlines.each do |row|
                length[row[0]] = 0 if !length.has_key?(row[0])
                listnumber[row[0]] = {} if !listnumber.has_key?(row[0])
                listnumber[row[0]][row[1]] = [] if !listnumber[row[0]].has_key?(row[1])
                listnumber[row[0]][row[1]].push(row[2])
                
                if row[0] != 'path'
                    if !member.has_key?(row[2]) && 
                        member[row[2]] = {}
                        member[row[2]].default = []
                        length[row[0]] += 1
                    end
                    
                    member[row[2]][row[0]] = [] if !member[row[2]].has_key?(row[0])
                    member[row[2]][row[0]].push(row[1])
                    
                end
            end
            return Sylfy::Feature.new(listnumber, member, length)
        end
        
        def self.fromKEGG(species = 'ref')
            
            listnumber = {}
            member = {}
            complist = Service::KEGGREST.link("compound/pathway")
            
            if species == 'ref'
                pathwaylist = Service::KEGGREST.list("pathway")
                genelist = Service::KEGGREST.link("ko/pathway")
                genelist.delete_if{|k, v| k !~ /^path:map/ }
                complist.delete_if{|k, v| k !~ /^path:map/ }
                
            else
                pathwaylist = Service::KEGGREST.list("pathway/#{species}")
                genelist = Service::KEGGREST.link("#{species}/pathway")
                tmp = {}
                complist.each_pair do |k, v|
                    tmp["path:#{species}#{k[-6..-1]}"] = v if !tmp.has_key?("path:#{species}#{k[-6..-1]}")
                end
                complist = tmp
            end
            
            listnumber["path"] = pathwaylist
            listnumber["gene"] = genelist
            listnumber["comp"] = complist
            
            length = {"path" => pathwaylist.length}
            genelist.each_pair do |k, v|
                v.each do |entry|
                    if !member.has_key?(entry)
                        member[entry] = {}
                        member[entry].default = []
                    end
                    
                    member[entry]["gene"] = [] if !member[entry].has_key?("gene")
                    member[entry]["gene"].push(k)
                end
            end
            
            @length["gene"] = member.length
            
            complist.each_pair do |k, v|
                v.each do |entry|
                    if !member.has_key?(entry)
                        member[entry] = {}
                        member[entry].default = []
                    end
                    
                    member[entry]["comp"] = [] if !member[entry].has_key?("comp")
                    member[entry]["comp"].push(k)
                end
            end
            
            @length["comp"] = member.length - @length["gene"]
            
            return Sylfy::Feature.new(listnumber, member, length)
            
        end
        #def enrichAnal(array, type = [])
        #    featureCount = {}
        #    array.each do |entry|
        #        if featureMember.has_key?(entry[1])
        #            
        #        end
        #        
        #        featureMember[entry[0]]
        #        featureCount[row[0]] = {} if !featureCount.has_key?(row[0])
        #        featureCount[row[0]][row[1]] = 0 if !featureCount[row[0]].has_key?(row[1])
        #    end
        #    
        #end
    end
    
end


