# 
# UniSysDB library in Ruby
# Copyright (C) 2012
#
# @author Natapol Pornputtapong <natapol@chalmers.se>
#
require 'open-uri'
require 'rexml/document'

module Sylfy

	module Service
		
		module Biocyc
			module REST
				@@baseuri = 'http://websvc.biocyc.org/apixml?'
				#~ @@prefix = { 'CAS Registry Number'=>'cas:', 'KEGG COMPOUND'=>'kegg.compound:', 'KEGG DRUG'=>'kegg.drug:', 'DrugBank'=>'drugbank:', 'PDBeChem'=>'pdb-ccd:' }
				
				module_function
				
				def apixml(apifn, id, detail = 'none')
					detail = 'none' if !['none', 'low', 'full'].include?(detail)
					uri = "#{@@baseuri}fn=#{apifn}&id=#{id}&detail=#{detail}"
					begin
						doc = REXML::Document.new(URI.parse(uri).read().strip())
					rescue OpenURI::HTTPError
						raise Unisys::ServiceException, "Id #{id} not found."
					end
					
					return doc
					
				end
				
				def reaction_reactants_and_products(id, detail = 'none')
					RESTBioCyc.apixml('enzymes-of-reaction', id, detail)
					#~ RESTBioCyc.apixml('reaction-reactants-and-products', id, detail)
				end
			end
		end
	end
end
