# @author Natapol Pornputtapong <natapol@chalmers.se>
#
require 'open-uri'
require 'net/http'
require 'rexml/document'
require 'json'
require 'yaml'

module Sylfy
	
	module Service
		
		module ENSEMBL
            
			module REST
				
				BASEURI = URI.parse('http://rest.genenames.org')
				HTTP = Net::HTTP.new(BASEURI.host, BASEURI.port)
				
				module_function
				# internal method supporting all ENSEMBLREST service
				#
				# @param get_path [String] service get_path
				#
				# @param option_type [Array] list of option type of service
				#
				# @param option [String] option of service please consult {http://beta.rest.ensembl.org/documentation/info/xref_id}
				#	
				# @return [array of Hash] results
				#
				def info()
					request = Net::HTTP::Get.new(get_path, {'Content-Type' => option.has_key?('content-type') ? option['content-type'] : 'application/json'})
					response = HTTP.request(request)
					
					if response.code != "200"
						#raise ParameterError, "Invalid response: #{response.code}"
					else
						#return YAML::dump(JSON.parse(response.body))
						if option.has_key?('content-type') && option['content-type'] != 'application/json'
							return response.body
						else
							return JSON.parse(response.body)
						end
					end
				end
			end
			
		end
		
	end
	
end