# @author Natapol Pornputtapong <natapol@chalmers.se>
#
require 'open-uri'
require 'net/http'
require 'rexml/document'


require 'sylfy/service/keggrest/conv'
require 'sylfy/service/keggrest/find'
require 'sylfy/service/keggrest/get'
require 'sylfy/service/keggrest/link'
require 'sylfy/service/keggrest/list'

module Sylfy
	
	module Service
		
		# interface to KEGG API
		# {http://www.kegg.jp/kegg/rest/keggapi.html}
		# info | list | find | get | conv | link
		module KEGGREST
			
			BASEURI = "http://rest.kegg.jp"
			
			DB = [:pathway, :brite, :module, :disease, :drug, :environ, 
					:ko, :genome, :compound, :glycan, :reaction, :rpair, 
					:rclass, :enzyme, :genomes, :genes, :ligand, :kegg, :organism]
			
			module_function
			
			
		end
		
	end
end


