# @author Natapol Pornputtapong <natapol@chalmers.se>
#

module Sylfy
	
	module Service
	
		module KEGGREST
			
			module_function
			# interface to KEGG link service
			#
			# @param targetdb [Symbol] can be pathway, :brite, :module, :disease, :drug, :environ, :ko, :genome, org, :compound, :glycan, :reaction, :rpair, :rclass, :enzyme
			#
			# @param sourcedb [Symbol] :pathway, :brite, :module, :disease, :drug, :environ, :ko, :genome, org, :compound, :glycan, :reaction, :rpair, :rclass, :enzyme, :genes
			#
			# @return [Hash] results with ID and description
			#
			def link(targetdb, *sourcedb)
				
				begin
					doc = URI.parse("#{Sylfy::Service::KEGGREST::BASEURI}/link/#{targetdb.to_s}/#{sourcedb.join("+")}").read().strip()
					result = {}
					
					doc.split(/\n/).each do |line|
						dat = line.chomp.split(/\t/)
						result[dat[0]] = result.has_key?(dat[0]) ? result[dat[0]].push(dat[1]) : [dat[1]]
					end
				
					return result
				rescue OpenURI::HTTPError
					raise Sylfy::Service::DataNotFound, "Query not found."
				end
				
			end
		
		end
		
	end
	
end
