# 
# Systems biology library for Ruby (Sylfy)
# Copyright::  Copyright (C) 2006
#              Toshiaki Katayama <k@bioruby.org>
# Copyright (C) 2012-2013
#
# author: Natapol Pornputtapong <natapol@chalmers.se>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"

require 'savon'
#namespaces = {
#  "xmlns:v2" => "http://v2.example.com",
#}
#
#Savon.client(namespaces: namespaces)
# debug log_level: :debug, log: true, pretty_print_xml: true
module Sylfy
    # A module supports as interfaces for web services
    module Service
        
        class SOAPWSDL
            # Initialize SOAP service
			#
			# == Parameters:
			# wsdl::
			#   
			# options::
			#	
            def initialize(wsdl, options = {})
                @options = options
                @options[:wsdl] = wsdl
                @options[:log] = false if !@options.has_key?(:log)
                @options[:pretty_print_xml] = true if @options.has_key?(:log_level) && @options[:log_level] == :debug
                @client = Savon.client(@options)
            end
            
            # List of methods defined by WSDL
            def list_methods
                @client.operations
            end
            
            def method_missing(m, *args, &block)
                response = @client.call(m, message: args[0])
                if @options[:log_level] == :debug
                    puts response.body 
                    puts response.success?     # => false
                    puts response.soap_fault?  # => true
                    puts response.http_error?
                end
                
                if response.body[:"#{m}_response"].has_key?(:"#{m}_return")
                    result = response.body[:"#{m}_response"][:"#{m}_return"]
                else
                    result = response.body[:"#{m}_response"][:return]
                end
                
                if result.class == Hash
                    result.delete_if {|k, v| k.to_s =~ /^@/}
                    return result.empty? ? "" : result
                else
                    return result
                end
            end
            
            private :method_missing
        end
        
    end
end


#a = Sylfy::Service::SOAPWSDL.new('http://www.ebi.ac.uk/webservices/chebi/2.0/webservice?wsdl')
#p a.list_methods
#p a.get_complete_entity(chebiId: '15377').keys #to_xml